<?php
//define('SYSTEM_ROOT', dirname(dirname(dirname(__FILE__)))); 
//echo SYSTEM_ROOT;
define('FILES_ROOT', ROOT_DIR.'/uploads/files/');
define('IMAGES_ROOT', ROOT_DIR.'/uploads/images/');





// v 1.2
// генерирует случайное название длиной $length
// $rand_name - можно использовать как приставку для начала названия
function get_rand_name ($length=20,$rand_name=''){
    for ($k=1;$k<=$length;$k++) {
        if ( rand(0, 5)==3 ) {
            $rand_name .= chr(48+rand(0, 9));
        } else {
            $rand_name .= chr(65+rand(0, 25));
        }
    }
    return strtolower($rand_name);
}



 /**
     * v 3.0
     * Изменение размеров изображения  (длина одной стороны генерируется пропорционально, по умолчанию высота)
     * @param string $name_old - имя исходного файла
     * @param string $name_new - имя генерируемого файла
     * @param integer $new_size - новый размер генерируемого изображения (или высота или ширина)
     * Необязательные параметры:
     * @param integer $quality - качество генерируемого JPEG, по умолчанию - 85
     * @param integer $auto - что считается автоматом, по умолчанию высота, значит $new_size будет шириной, если надо наоборот указываем любое другое значение, например width
     * @return bool
     */
function img_resize($name_old, $name_new, $new_size, $quality=100, $auto='height') {
    if (!file_exists($name_old)) return false;
    $size = getimagesize($name_old);
    if ($size === false) return false;
    // Определяем исходный формат по MIME-информации, предоставленной
    // функцией getimagesize, и выбираем соответствующую формату
    // imagecreatefrom-функцию.
    $format = strtolower(substr($size['mime'], strpos($size['mime'], '/')+1));
    $icfunc = "imagecreatefrom" . $format;
    if (!function_exists($icfunc)) return false;
    // Создаем новое изображение
    // если автоматом высота, то ширина будет $new_size и наоборот
    $height = ($auto=='height') ? $new_size * $size[1] / $size[0]: $new_size ;
    $width = ($auto=='height') ? $new_size : $new_size * $size[0] / $size[1];
    $idest = imagecreatetruecolor($width, $height);
    $isrc = $icfunc($name_old);
    // Копируем существующее изображение в новое с изменением размера:
    imagecopyresampled(
        $idest,  // Идентификатор нового изображения
        $isrc,  // Идентификатор исходного изображения
        0,0,      // Координаты (x,y) верхнего левого угла
        // в новом изображении
        0,0,      // Координаты (x,y) верхнего левого угла копируемого
        // блока существующего изображения
        $width,     // Новая ширина копируемого блока
        $height,     // Новая высота копируемого блока
        $size[0], // Ширина исходного копируемого блока
        $size[1]  // Высота исходного копируемого блока
    );
    if(imagejpeg($idest, $name_new, $quality)) {
        imagedestroy($isrc);
        imagedestroy($idest);
        return true;
    } else {
        return false;
    }
}
    


/** v 3.0
 * Функция транслитерации.
 *
 * @param string $text текст для транслитерации
 * @return string транслитерированную строку
 * @author sympler www.unibix.ru
 */
function translit($text) {
    $converter = array(
        'а' => 'a',   'б' => 'b',   'в' => 'v',
        'г' => 'g',   'д' => 'd',   'е' => 'e',
        'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
        'и' => 'i',   'й' => 'y',   'к' => 'k',
        'л' => 'l',   'м' => 'm',   'н' => 'n',
        'о' => 'o',   'п' => 'p',   'р' => 'r',
        'с' => 's',   'т' => 't',   'у' => 'u',
        'ф' => 'f',   'х' => 'h',   'ц' => 'c',
        'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
        'ь' => '',    'ы' => 'y',   'ъ' => '',
        'э' => 'e',   'ю' => 'yu',  'я' => 'ya',
        
        'А' => 'A',   'Б' => 'B',   'В' => 'V',
        'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
        'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
        'И' => 'I',   'Й' => 'Y',   'К' => 'K',
        'Л' => 'L',   'М' => 'M',   'Н' => 'N',
        'О' => 'O',   'П' => 'P',   'Р' => 'R',
        'С' => 'S',   'Т' => 'T',   'У' => 'U',
        'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
        'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
        'Ь' => '',    'Ы' => 'Y',   'Ъ' => '',
        'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',
    );
    return strtr($text, $converter);
}

/** v 3.1
 * Функция транслитерации в URL для SEO.
 *
 * @param string $text текст для транслитерации
 * @return string транслитерированную строку
 * @author sympler www.unibix.ru
 */
function str2url($text) {
    // переводим в транслит
    $text = translit($text);
    // в нижний регистр
    $text = strtolower($text);
    // пробел на тире
    $converter = array( '   ' => '-',   '  ' => '-',  ' ' => '-','--' => '-');
    $text = strtr($text,$converter);
    // удаляем все лишнее
    $text = preg_replace('/[^a-z0-9\._-]/u', '', $text);
    // удаляем начальные и конечные '-' и пробел
    $text = trim(trim($text), "-");
    return $text;
}


?>