<?php 

/**
* класс текстовых страниц
*/
class controller_component_core_pages extends component {
	

	function action_index() {
		
		$page_info = $this->model->get_page('/');
		
		$this->data['page_name'] = $page_info['name'];
		$this->data['content'] = $page_info['text'];
		$page['title'] = $page_info['title'];
		$page['keywords'] = $page_info['keywords'];
		$page['description'] = $page_info['description'];
		$this->data['bread_crumbs'] = 'Вы на главной странице.';
		$page['html'] = $this->load_view();

		return $page;
	}

	// вывод страниц за исключением главной
	function action_else() {
		$not_found = false;
		$this->data['bread_crumbs'] = '<a href="/">Главная</a>';
		$url = SITE_URL;
		if($this->url['actions'][0] == 'index') {
			$page_info = $this->model->get_page($this->url['component']);
			$url .= '/' . $page_info['url'];
			$this->data['bread_crumbs'] .= '&#8594; <a href="' . $url . '">'.$page_info['name'].'</a> ';
			
		} else {
			$first = $this->model->get_main_info($this->url['component']);
			$parent_id = $first['id'];
			$url .= '/' . $first['url'];
			$this->data['bread_crumbs'] .= ' &#8594; <a href="' . $url . '">'.$first['name'].'</a> ';
			
			foreach($this->url['actions'] as $i => $action) {
				$main_info = $this->model->get_main_info($action, $parent_id);
				if($main_info) {
					$url .= '/' . $main_info['url'];
					$this->data['bread_crumbs'] .= ' &#8594; <a href="' . $url . '">'.$main_info['name'].'</a>  ';
				
					$parent_id = $main_info['id'];
					if(isset($this->url['actions'][$i++])) { // это нужная нам страница
						$page_info = $this->model->get_page($main_info['url'], $main_info['parent_id']);
					}
				} else {
					$not_found = true;
					break;
				}
			}
		}
		
		if($not_found) {
			$page['title'] = 'Страница не найдена';
			$page['keywords'] = 'Страница не найдена';
			$page['description'] = 'Страница не найдена';
			$this->action_404();
			
		} else {
			$this->data['page_name'] = $page_info['name'];
			$this->data['content'] = $page_info['text'];
			$page['title'] = $page_info['title'];
			$page['keywords'] = $page_info['keywords'];
			$page['description'] = $page_info['description'];
		}

		$page['html'] = $this->load_view();

		return $page;
	}

	
}